package cap7;
import java.io.*;
import cap7.listincidencia.HiperGrafo; /*-- vide Programa@{\it ~\ref{prog:tipoabstratohipergrafo}@ --*/
public class TestaHiperGrafo {
  static BufferedReader in = new BufferedReader (
                             new InputStreamReader (System.in));
  public static HiperGrafo.Aresta lerAresta (int r) throws Exception {
    System.out.println ("Aresta:");
    int vertices[] = new int[r];
    for (int i = 0; i < r; i++) {
      System.out.print ("  V"+i+":");
      vertices[i] = Integer.parseInt (in.readLine());
    }
    System.out.print ("  Peso:");
    int peso = Integer.parseInt (in.readLine());
    return new HiperGrafo.Aresta (vertices, peso);
  }
  public static void main (String[] args) throws Exception {
    System.out.print ("No. vertices:"); 
    int nVertices = Integer.parseInt (in.readLine());
    System.out.print ("No. arestas:"); 
    int nArestas = Integer.parseInt (in.readLine());
    System.out.print ("r:"); 
    int r = Integer.parseInt (in.readLine());
    HiperGrafo grafo = new HiperGrafo (nVertices, nArestas, r);
    for (int i = 0; i < nArestas; i++) {
      HiperGrafo.Aresta a = lerAresta (r);
      grafo.insereAresta (a.vertices(), a.peso ());     
    }
    grafo.imprime ();  in.readLine();    
    System.out.print ("Lista de arestas incidentes em: "); 
    int v1 = Integer.parseInt (in.readLine());
    if (!grafo.listaIncVazia (v1)) {
      HiperGrafo.Aresta adj = grafo.primeiraListaInc (v1);
      while (adj != null) {
       System.out.println ("  " + adj);
       adj = grafo.proxInc (v1);       
      }
      System.out.println (); in.readLine();
    }
    System.out.println ("Retira aresta: ");
    HiperGrafo.Aresta a = lerAresta (r);
    if (grafo.existeAresta (a.vertices ())) {
      HiperGrafo.Aresta b = grafo.retiraAresta (a.vertices ());
      HiperGrafo.Aresta c = grafo.retiraAresta (a.vertices ()); 
      System.out.println ("aresta b: " + b);
      System.out.println ("aresta c: " + c);
    }
    else System.out.println ("Aresta nao existe");
    grafo.imprime (); in.readLine();
    System.out.print ("Existe aresta: "); a = lerAresta (r);
    if (grafo.existeAresta (a.vertices ())) 
     System.out.println ("  Sim");
    else System.out.println ("  Nao");
  }
}
